﻿/*

Класс для работы с игровыми событиями и действиями.

*/



function GameAction(_ActionConfig, _GameItem) {

    //console.log("game action create for " + _GameItem.name);
    this.eventObjects = new Array();

    this.finished = false;

    this.actionType = _ActionConfig.ActionType;
    this.actionConfig = _ActionConfig;

    this.delay = 0;

    this.gameItem = _GameItem;

    this.GameActionFunctions = {};

    this.GameActionFunctions["oscillationY"] = startOscillationY;
    this.GameActionFunctions["oscillationScale"] = startOscillationScale;
    this.GameActionFunctions["oscillationAlpha"] = startOscillationAlpha;
    this.GameActionFunctions["rescalePeriod"] = startRescale;
    this.GameActionFunctions["visible"] = startChangeVisible;
    this.GameActionFunctions["click"] = startClick;
    this.GameActionFunctions["flash"] = startFlash;
    this.GameActionFunctions["movePeriod"] = startMove;
    this.GameActionFunctions["move"] = startMoveToPoint;

    if (!!_ActionConfig.Delay)
    {
        this.delay = parseInt(_ActionConfig.Delay);
    }

    this.execute = function (_StateTime) {
        if (this.finished == true) {
            return true;
        }
        if (_StateTime >= this.delay && this.checkCondition() == true)
        {
           // console.log("game action execute st " + _StateTime + " delay " + this.delay);
            this.start();
            this.finished = true;
        }
        return this.finished;
    }

    this.start = function ()
    {
 //       console.log("game action item start");
        this.GameActionFunctions[this.actionType](this);
    }

    this.checkCondition = function ()
    {
        if (!!!_ActionConfig.Condition)
        {
            return true;
        }
    //    console.log("check action condition " + _ActionConfig.Condition);


        pos1 = _ActionConfig.Condition.indexOf("=");
        if (pos1 > -1) {
            var ConditionName = _ActionConfig.Condition.substr(0,pos1);
            var ConditionValue = _ActionConfig.Condition.substr(pos1+1);

        

            if (g_Conditions[ConditionName] == parseInt(ConditionValue))
            {
                //    console.log("ConditionName " + ConditionName);
                //    console.log("ConditionValue " + ConditionValue);

                //   console.log("g_Conditions[ConditionName] " + g_Conditions[ConditionName]);
               //    console.log("parseInt(ConditionValue) " + parseInt(ConditionValue));

               // console.log("ConditionValue success");
                return true;

            }
            return false;
        }
        else
        {
            return true;
        }
        return false;
    }

    //if (pos2 == -1) {
    //    objectIndex = itemname.substr(pos1 + this.name.length)
    //}
    //else {
    //    objectIndex = itemname.substring(pos1 + this.name.length, pos2)
    //}
}

    


startOscillationY = function (_action) //колебание объекта по оси Y
{
    var _startY = _action.actionConfig.Start;
    var _endY = _action.actionConfig.End;
    var _period = _action.actionConfig.Period;

    //console.log("startOscilationY : " + _startY + " : " + _endY + " : " + _period);

    var moveDown;
    var moveUp;

    moveDown = game.add.tween(_action.gameItem.display).to({ y: parseInt(_endY) }, _period);
    moveUp = game.add.tween(_action.gameItem.display).to({ y: parseInt(_startY) }, _period);

    _action.eventObjects.push(moveDown);
    _action.eventObjects.push(moveUp);

    moveDown.chain(moveUp);
    moveUp.chain(moveDown);
    moveDown.start();
}

startOscillationScale = function (_action) //колебание объекта по оси Y
{
    var _start = _action.actionConfig.StartScale;
    var _end = _action.actionConfig.EndScale;
    var _period = _action.actionConfig.Period;

    //console.log("startOscilationY : " + _startY + " : " + _endY + " : " + _period);

    var moveDown;
    var moveUp;

    var tween1
    var tween2

    _action.gameItem.changeVisible(true);


    tween1 = game.add.tween(_action.gameItem.display.scale).to({ x: parseFloat(_end), y: parseFloat(_end) }, _period);
    tween2 = game.add.tween(_action.gameItem.display.scale).to({ x: parseFloat(_start), y: parseFloat(_start) }, _period);


    _action.eventObjects.push(tween1);
    _action.eventObjects.push(tween2);

    

    
    tween1.chain(tween2);
    tween2.chain(tween1);
    tween1.start();
}

startOscillationAlpha = function (_action) //колебание объекта по оси Y
{
    var _start = _action.actionConfig.StartAlpha;
    var _end = _action.actionConfig.EndAlpha;
    var _period = _action.actionConfig.Period;

    //console.log("startOscilationY : " + _startY + " : " + _endY + " : " + _period);

    var moveDown;
    var moveUp;

    var tween1
    var tween2

    _action.gameItem.changeVisible(true);


    tween1 = game.add.tween(_action.gameItem.display).to({ alpha: parseFloat(_end) }, _period);
    tween2 = game.add.tween(_action.gameItem.display).to({ alpha: parseFloat(_start) }, _period);


    _action.eventObjects.push(tween1);
    _action.eventObjects.push(tween2);




    tween1.chain(tween2);
    tween2.chain(tween1);
    tween1.start();
}



startRescale = function (_action)
{
    var _start = _action.actionConfig.StartScale;
    var _end = _action.actionConfig.EndScale;
    var _period = _action.actionConfig.Period;

    //_action.gameItem.rescale(parseFloat(_start));
    _action.gameItem.changeVisible(true);
    _action.gameItem.display.scale.x = parseFloat(_start);
    _action.gameItem.display.scale.y = parseFloat(_start);
    

    var tween1
   

    tween1 = game.add.tween(_action.gameItem.display.scale).to({ x: parseFloat(_end), y: parseFloat(_end) }, _period);
    _action.eventObjects.push(tween1);
    tween1.start();
}

startMove = function (_action) {
    var _endX = parseInt(_action.actionConfig.EndX);
    var _endY = parseInt(_action.actionConfig.EndY);
    var _period = parseInt(_action.actionConfig.Period);

    _action.gameItem.changeVisible(true);


    var tween1

    tween1 = game.add.tween(_action.gameItem.display).to({ x: _endX, y: _endY }, _period);
   
    _action.eventObjects.push(tween1);
    tween1.start();
}

startMoveToPoint = function (_action) {
    var _endX = parseInt(_action.actionConfig.EndX);
    var _endY = parseInt(_action.actionConfig.EndY);
   
    _action.gameItem.changeVisible(true);
    _action.gameItem.remove(_endX,_endY);


//    var tween1

//    tween1 = game.add.tween(_action.gameItem.display).to({ x: _endX, y: _endY }, _period);
   
    //_action.eventObjects.push(tween1);
    //tween1.start();
    
}

startFlash = function (_action)
{
    console.log("start flash " + _action.gameItem.name);

    var _period = _action.actionConfig.Period;
    
    var moveDown;
    var moveUp;

    _action.gameItem.changeVisible(true);
    _action.gameItem.display.alpha = 0;

    game.world.bringToTop(_action.gameItem.display);

    moveDown = game.add.tween(_action.gameItem.display).to({ alpha: 1 }, _period);
    moveUp = game.add.tween(_action.gameItem.display).to({ alpha: 0 }, _period);

    _action.eventObjects.push(moveDown);
    _action.eventObjects.push(moveUp);

    moveDown.chain(moveUp);
   // moveUp.chain(moveDown);
    moveDown.start();
}

startChangeVisible = function (_action) //появление объекта
{
    var _visible;
    if (_action.actionConfig.Visible == "true") {
        _visible = true;
    }
    else {
        _visible = false;
    }
    _action.gameItem.changeVisible(_visible);
}

startClick = function (_action)
{
    _action.gameItem.startClick();
}