﻿/*

Класс для работы с игровыми объектами.

*/

function GameItem(ItemConfig,nLevel) //передаем ссылку на Json конфиг
{
  // if (nParentItem != 0)
  //  {
  //      
    //  }

    this.anchor = 0;

    this.type = "item";

    this.name = ItemConfig.Name;
    this.level = nLevel;

    //console.log("Game item construct " + this.name + " where level is " + this.level)
    this.startX = 0;
    this.startY = 0;

   // this.scale = 1;
    
    this.scaleX = 1;
    this.scaleY = 1;

    this.x = parseInt(ItemConfig.X);
    this.y = parseInt(ItemConfig.Y);
    this.z = parseInt(ItemConfig.Z);
    this.sizeX = parseInt(ItemConfig.SizeX);
    this.sizeY = parseInt(ItemConfig.SizeY);
    this.poly = new Phaser.Polygon([this.x, this.y,  this.x + this.sizeX, this.y,  this.x + this.sizeX, this.y + this.sizeY, this.x,this.y+this.sizeY,this.x,this.y])

    this.childItems = new Array(); //массив дочерних объектов

    if (!!ItemConfig.OnClick)
    {
        this.onClick = ItemConfig.OnClick;
    }

    if (!!ItemConfig.Scale) {
        this.scale = parseFloat(ItemConfig.Scale);
    }

    if (!!ItemConfig.Anchor) {
        if (ItemConfig.Anchor == "center")
        {
            this.anchor = 0.5;
        }
    }
    else
    {
    //	console.log("change anchor");
    	this.anchor = 0.5;
    	this.x = this.x + this.sizeX/2;
    	this.y = this.y + this.sizeY/2;
    }
    

    if (ItemConfig.Visible == "true") {
        this.visible = true;
    }
    else {
        this.visible = false;
    }

    this.createdDisplay = false;

    //console.log("this.visible : " + this.visible);

    this.FrameCount = parseInt(ItemConfig.FrameCount);
    this.itemType = ItemConfig.Type;
    
    this.animationSpeed = parseInt(ItemConfig.AnimationSpeed);
    this.anim=0;
    this.animationOrder="";
    if (!!ItemConfig.AnimationOrder)
    {
        this.animationOrder = ItemConfig.AnimationOrder;
    }
    


    this.gameActions = new Array(); //настройки действий
    this.gameActionsFinished = new Array(); //
    this.display = 0; // спрайт рисунка
    this.bmd = 0;

    this.isClicked = false;


   // this.ObjsOscillationY = new Array(); //объекты для осцилляций по вертикали

    //Иницилизация дочерних объектов
    if (this.itemType == "group")
    {
        //console.log("Find group object with " + ItemConfig.ItemsCount + " children");
        for (var k = 0; k < ItemConfig.ItemsCount; k++) {
            this.childItems.push(new GameItem(ItemConfig.Items[k], nLevel+1));
        }
    }


    this.create = function (_x, _y) { //создаем объекты с нужной видимостью
        this.startX = parseInt(_x);
        this.startY = parseInt(_y);

        if (this.itemType == "image") {
            if (this.visible == true)
            {
                console.log("create item " + this.name);
                this.display = game.add.sprite(this.x * this.scaleX + _x, this.y * this.scaleY + _y, this.name);
                this.display.anchor.set(this.anchor);
                this.display.visible = this.visible;
                this.display.scale.x = this.scaleX;
                this.display.scale.y = this.scaleY;
                
                this.createdDisplay = true;
            }
        }
        else if (this.itemType == "button")
        {
            console.log("create button " + this.name + " : onclick : " + this.onClick);
            this.display = game.add.button(this.x * this.scaleX + _x, this.y * this.scaleY + _y, this.name, functions[this.onClick], this, 2, 1, 0);
//            if (this.name == "3_left")
//            {
//            	this.display.onInputDown.add(leftDown,this);
//            	this.display.onInputUp.add(leftUp,this);
//            }
            
            this.display.anchor.set(this.anchor);
            this.display.visible = this.visible;
            this.display.scale.x = this.scaleX;
            this.display.scale.y = this.scaleY;
            this.createdDisplay = true;
        }
        else if (this.itemType == "animation")
        {
            console.log("create animation");
            this.display = game.add.sprite(this.x * this.scaleX + _x, this.y * this.scaleY + _y, this.name, 4);
            this.display.anchor.set(this.anchor);
            this.display.visible = this.visible;
            this.display.scale.x = this.scaleX;
            this.display.scale.y = this.scaleY;
           
            if (this.name.indexOf("Anna") >= 0)
            {
         //       console.log("create animation for anna");
                this.anim = this.display.animations.add(this.name, [0, 3, 1, 2]);
            }
            else if (this.name.indexOf("Elsa") >= 0)
            {
         //       console.log("create animation for elsa");
                this.anim = this.display.animations.add(this.name);
            }
            else
            {
        //        console.log("create animation for another");
                this.anim = this.display.animations.add(this.name, [0, 3, 1, 2]);
            }
            this.createdDisplay = true;
            
          //  this.anim.scale.x = this.scale;
          //  this.anim.scale.y = this.scale;
            this.anim.onComplete.add(this.animationStopped, this);
            this.animStart();
            //game.time.events.add(getRandomInt(500,1500), this.animStart, this);
        }

        for (var k = 0; k < this.childItems.length; k++) {
            this.childItems[k].create(_x,_y);
        }
        
    }

    this.animationStopped = function ()
    {
        game.time.events.add(getRandomInt(1000, 5000) + this.x*3, this.animStart, this);
    }

    this.animStart = function ()
    {
        //     console.log("start animation " + this.name + " " + game.time.totalElapsedSeconds());
        if (this.anim != 0)
        {
            this.anim.play(this.animationSpeed, false);
        }
        
    }

    this.destroy = function () { //перед сменой состояний удаляем  все объекты
      //  console.log("item destroy " + this.name);
        if (this.createdDisplay == true)
        {
            this.display.destroy();
        }
        //if (this.bmd != 0)
        //{
        //    this.bmd.destroy();
        //}
        if (this.anim != 0)
        {
            //  this.anim.stop();
            
            this.anim.destroy();
            this.anim = 0;
        }
       
        for (var k = 0; k < this.childItems.length; k++) {
            this.childItems[k].destroy();
        }

        this.gameActions.length = 0;
        this.gameActionsFinished.length = 0;
        this.childItems.length = 0;

    }

    this.getItemByName = function (_name) {
        var res=0;

        if (this.name == _name)
        {
            return this;
        }

        for (var k = 0; k < this.childItems.length; k++) {
            res = this.childItems[k].getItemByName(_name);
            if (res!=0)
            {
                return res;
            }
        }
        return 0;

    }

    this.addActions = function (_ItemActions) { //иницилизация действий
        
        for (var i = 0; i < _ItemActions.length; i++)
        {
           // console.log("try action : " + _ItemActions[i].Name);
          //  console.log("try add to item : " + this.name);
            if (_ItemActions[i].Name == this.name)
            {
           //     console.log("addActions : " + this.name);
                for (var k = 0; k < _ItemActions[i].Actions.length; k++)
                {
                    this.gameActions.push(new GameAction(_ItemActions[i].Actions[k], this));
                    for (var l = 0; l < this.childItems.length; l++) {
                        this.childItems[l].addActionToItem(_ItemActions[i].Actions[k]);
                    }
                    //console.log("this.actions[" + k + "].ActionType : " + _ItemActions[i].Actions[k].actionType);
                }
            }
        }

        for (var k = 0; k < this.childItems.length; k++) {
            this.childItems[k].addActions(_ItemActions);
        }
        
    }

    this.addActionToItem = function (_ItemAction)
    {
    //    console.log("addActionToItem : " + this.name);
        this.gameActions.push(new GameAction(_ItemAction, this));
        for (var k = 0; k < this.childItems.length; k++) {
            this.childItems[k].addActionToItem(_ItemAction);
        }
    }
    
    this.startActions = function () {
        this.executeActions(0);
        
    }

    this.executeActions = function (_StateTime) {
        this.gameActions.forEach(function (item, i, arr) {
            item.execute(_StateTime);
        }, this);

        //исполняем действия для дочерних узлов
        for (var k = 0; k < this.childItems.length; k++) {
            this.childItems[k].executeActions(_StateTime);
        }
        
    }

    this.startClick = function ()
    {
       // 
        this.isClicked = true;

        //if (this.childItems.length == 0)
        //{
        //console.log("startClick : " + this.name + ". Time : " + game.time.totalElapsedSeconds());
        //    //this.bmd = game.make.bitmapData(0, 0);
        //    //this.bmd.load(this.name);
        //}
        
    }

    this.checkClick = function (x,y)
    {
   //     console.log("checkClick : " + this.name);
      //  console.log("this.isClicked : " + this.isClicked);
 //       console.log("this.visible : " + this.visible);
        
        var Res="";
        var FinalRes=""

        if (this.childItems.length == 0)
        {
            if (this.isClicked == false || this.visible == false)
            {
                return "";
            }

          //  console.log("checkClick : " + this.name);
         //   console.log("poly contains " + this.poly.contains(x,y))

            if (this.poly.contains(x, y) == true)
            {
                return this;
            }

            //var localX = x - this.x;
            //var localY = y - this.y;
            //if (this.bmd != 0)
            //{
            //    var color = this.bmd.getPixel32(localX, localY);
            //    if (color > 0) {
            //        return this;
            //    }
            //}
            return "";
        }
        for (var k = 0; k < this.childItems.length; k++) {
            Res = this.childItems[k].checkClick(x, y);
            if (Res != "")
            {
                if (FinalRes == "") {
                    FinalRes = Res
                }
                else {
                    //console.log("FinalRes.z : " + FinalRes.z + " : " + FinalRes.name);
                    //console.log("Res.z : " + Res.z + " : " + Res.name);
                    if (FinalRes.z > Res.z) {
                        //console.log("change final res");
                        FinalRes = Res;
                    }
                }
            }
            
        }
        return FinalRes;
    }

    this.changeVisible = function (_visible)
    {
       
        this.visible = _visible;
        if (this.childItems.length == 0)
        {
            if (this.itemType == "image")
            {
            //   console.log("changeVisible : " + this.name + " new visible : " + _visible + " display " + this.createdDisplay);
                if (this.createdDisplay == false && _visible == true) {
                   // console.log("create display: " + this.name + " new visible : " + _visible);
                    this.display = game.add.sprite(this.x + this.startX, this.y + this.startY, this.name);
                    this.display.anchor.set(this.anchor);
                    this.display.scale.x = this.scaleX;
                    this.display.scale.y = this.scaleY;
                    this.createdDisplay = true;
                    
                    console.log("this.display.x :" +  this.display.x);
                    console.log("this.display.y :" + this.display.y);
                    
                    g_States[g_StateNumber - 1].needReorder = true;
                }
            }
            if (this.itemType == "animation")
            {
                this.display.scale.x = this.scaleX;
                this.display.scale.y = this.scaleY;
            }
            if (this.itemType != "virtual")
            {
                this.display.visible = _visible;
            }
            
        }
        else
        {
            for (var k = 0; k < this.childItems.length; k++) {
                this.childItems[k].changeVisible(_visible);
            }
        }
        
    }

    this.remove = function (_x,_y)
    {
        this.startX = parseInt(_x);
        this.startY = parseInt(_y);
        if (this.display != 0) {
            this.display.x = this.x * this.scaleX + this.startX;
            this.display.y = this.y * this.scaleY + this.startY;
        	
        	// this.display.x += parseInt(_x);
        	 //this.display.y += parseInt(_y);
             // this.display.y = this.y + this.startY;
            
         //   console.log("remove item " + this.name);
        //    console.log("this.display.x :" +  this.display.x);
        //    console.log("this.display.y :" + this.display.y);
            
        }
        for (var k = 0; k < this.childItems.length; k++) {
            this.childItems[k].remove(_x, _y);
        }
    }

    this.rescale = function (_scale) {
   //     this.scale = _scale;
        this.rescaleXY(_scale,_scale);
    }
    
    this.rescaleXY = function (_scaleX,_scaleY)
    {
    	this.scaleX = parseFloat(_scaleX);
        this.scaleY = parseFloat(_scaleY);
        if (this.display != 0) {
        	
//        	console.log("rescale item " + this.name);
//            console.log("this.display.x :" +  this.display.x);
//            console.log("this.display.y :" + this.display.y);
//            console.log("this.display.scale.x :" +  this.display.scale.x);
//            console.log("this.display.scale.y :" + this.display.scale.y);
            
            this.display.scale.x = this.scaleX;
            this.display.scale.y = this.scaleY;
          //  this.display.anchor.set(0.5);
            this.display.x = this.x * this.scaleX + this.startX;
            this.display.y = this.y * this.scaleY + this.startY;
            //this.x = this.x * this.scaleX;
            //this.y = this.x * this.scaleY;
            
//            console.log("this.display.x :" +  this.display.x);
//            console.log("this.display.y :" + this.display.y);
        }
        for (var k = 0; k < this.childItems.length; k++) {
            this.childItems[k].rescaleXY(_scaleX,_scaleY);
        }
    }


  
}



