﻿
//Игровой пользовательский объект, может присутствовать в нескольких состояниях

function GameObject(_name)
{
    this.name = _name
    this.type = "object";

    // отображаемые объекты
    this.objectItems = new Array();

    this.visible = true;

    this.x = 0;
    this.z = 0;
    this.y = 0;
    
    this.cameraX = 0;

    this.scale = 1;


    
    // названия свойства объекта которыми надо управлять на каждом экране.
    this.properties = ['hair','ac','sh','dress','hair_back','dress_back'];
    // значения свойств объекта
    this.values = {};

    //Инилизируем без одежды
    for (var k = 0; k < this.properties.length; k++)
    {
        this.values[this.properties[k]] = 0;
    }

    this.ConsoleState = function()
    {
        console.log("Print state object " + this.name);
        for (var k = 0; k < this.properties.length; k++) {
            console.log(this.properties[k] + " = " + this.values[this.properties[k]]);
        }
    }

    this.setNaked = function()
    {
        for (var k = 0; k < this.properties.length; k++) {
            this.values[this.properties[k]] = 0;
        }
    }
   

    this.loadConfig = function()
    {
        console.log("Load json config for " + this.name);
        game.load.json(this.name, 'assets/' + this.name + '/' + this.name + '.json');
    }

    this.loadResources = function()
    {
        console.log("loadResources config for " + this.name);
        objectConfig = game.cache.getJSON(this.name);
        LoadResources(objectConfig);
    }

    this.move = function(_x,_y)
    {
        this.x = _x;
        this.y = _y;
        this.cameraX = _x;
    }

    this.remove = function (_x, _y) {
        this.x = _x;
        this.y = _y;
        for (var k = 0; k < this.objectItems.length; k++) {
            this.objectItems[k].remove(this.x, this.y);
        }
    }

    this.changeVisible = function (_visible) {
        this.visible = _visible;
        //for (var k = 0; k < this.objectItems.length; k++) {
        //    this.objectItems[k].changeVisible(_visible);
        //}
    }

    this.rescale = function(_scale)
    {
    	console.log("rescale " + this.name);
        this.scale = _scale;
        for (var k = 0; k < this.objectItems.length; k++) {
            this.objectItems[k].rescale(_scale);
        }
    }
    
    this.rescaleXY = function(_scaleX,_scaleY)
    {
    	console.log("rescale " + this.name);
        //this.scale = _scale;
        for (var k = 0; k < this.objectItems.length; k++) {
            this.objectItems[k].rescaleXY(_scaleX,_scaleY);
        }
    }

    this.destroy = function()
    {

        console.log ("destroy object")
        for (var k = 0; k < this.objectItems.length; k++) {
            this.objectItems[k].destroy();
        }
        this.objectItems.length = 0;
    }

    this.create = function()
    {
        console.log("Game object " + this.name + " create. Time : " + game.time.totalElapsedSeconds());

        var objectConfig = game.cache.getJSON(this.name);
        for (var k = 0; k < objectConfig.ItemsCount; k++) {
            this.objectItems.push(new GameItem(objectConfig.Items[k], 0));
            this.objectItems[k].create(this.x,this.y);
        }
    }

    
    this.SelectItem = function(_Item) //игровой объект на который кликнули
    {
        var itemname = _Item.name;
        var FindItem = false
        var k
        var objectIndex = 0;
        var itemType;
        
        for (k = 0; k < this.properties.length; k++)
        {
            if( itemname.indexOf(this.properties[k])>-1)
            {
                FindItem = true;
                break;
            }
        }
        
        if (FindItem == true)
        {
            itemType = this.properties[k];
         //   console.log("select group : " + itemType);

            var pos1
            var pos2

            pos1 = itemname.indexOf("all");
        	if (pos1 > -1)
        	{
        		//если встретили all подставляем имя текущей девочки
        		itemname = itemname.replace("all",g_Girl.name);
        	}
        
            pos1 = itemname.indexOf(this.name);
            if (pos1 > -1) {
                pos2 = itemname.indexOf("_", pos1);
                if (pos2 == -1) {
                    objectIndex = itemname.substr(pos1 + this.name.length);
                }
                else {
                    objectIndex = itemname.substring(pos1 + this.name.length, pos2);
                }
            }
            else
            {
            	this.ProcessClick(_Item);
            	return;
            }

           

  //          console.log("select index : " + objectIndex);

            if (this.values[itemType] == objectIndex)
            {
                //снимаем вещь при двойном клике
                if (itemType == 'ac' || itemType == 'sh')
                {
                    objectIndex = 0;
                }
            }
            
            this.values[itemType] = objectIndex;
            

            //if (itemType == 'jev1') {
            //    this.values['jev2'] = objectIndex;
            //}

            if (itemType == "hair")
            {
                this.values['hair_back'] = objectIndex;
            }
//
            if (itemType == "dress") {
                this.values['dress_back'] = objectIndex;
            }
//
//            if (itemType == "dress_vecher") {
//                this.values['dress_back_vecher'] = objectIndex;
//            }
//
//            if (itemType == "as1_casual") {
//                this.values['as_back_casual'] = objectIndex;
//            }

          //  if (itemType == "as2_casual") {
            //    this.values['as_back_casual'] = objectIndex;
            //}

//            if (itemType == 'up_casual' || itemType == 'down_casual') {
//                this.values['dress_casual'] = 0;
//            }
//
//            if (itemType == 'dress_casual') {
//                this.values['up_casual'] = 0;
//                this.values['down_casual'] = 0;
//            }
//
//            if (itemname == "5_as1_vecher_cindy1_icon" && this.values['as1_vecher']==0)
//            {
//                this.values['as1_vecher'] = 5;
//            }

            //if (itemname == "5_as1_vecher_cindy1_icon" && this.values[itemType] ==0) {
            //    this.getItemByName("cindy_fingers_cindy").changeVisible(true);
            //}

      //      this.ConsoleState();
        }
        else
        {
      //      console.log("item not found : " + itemname);
            this.ProcessClick(_Item);
        }
        
        

    }

    this.ProcessClick = function () {

    }

    this.getItemByName = function (_name) {
        var res = 0;

        for (var k = 0; k < this.objectItems.length; k++) {

            if (this.objectItems[k].name == _name) {
                return this.objectItems[k];
            }
        }

        for (var k = 0; k < this.objectItems.length; k++) {
            res = this.objectItems[k].getItemByName(_name);
            if (res != 0) {
                return res;
            }
        }
        return 0;
    }

    this.redraw = function()
    {
        console.log("default object redraw " + this.name);
        RedrawGirl(this);
    }


}

