﻿/*

Класс для работы с игровыми состояними.

*/

function compareItemsZ(a, b) {
    if (a.z > b.z) return 1;
    if (a.z < b.z) return -1;
}


function orderByZ(_stateItems) //раскладывание по оси Z всех элементов
{
   // console.log("Start orderByZ ")
    _stateItems.sort(compareItemsZ);

    for (var k = _stateItems.length - 1; k >= 0; k--) {
        
        if (_stateItems[k].type == "item")
        {
            if (_stateItems[k].childItems.length == 0) {
           //     console.log("_stateItems[k] " + _stateItems[k].name);
                game.world.bringToTop(_stateItems[k].display);
            }
            else
            {
       //         console.log("child _stateItems[k] " + _stateItems[k].name);
                orderByZ(_stateItems[k].childItems);
            }
        }
        if (_stateItems[k].type == "object")
        {
     //       console.log("_stateItems[k] " + _stateItems[k].name);
            orderByZ(_stateItems[k].objectItems);
        }
        
        
    }
}

function GameState(_state,_stateName,_stateNumber) //передаем игровой объект
{
    console.log("game state constructor");

    this.state = _state;
    this.stateName = _stateName;
    this.stateNumber = _stateNumber;
    this.stateItems = new Array();
    this.commonItems = new Array();
   

    this.stateTime = 0; //время с начала состояния
    this.stateTimer = 0;
    
    this.cameraMovement = false;
    this.tap = false;
    this.lastX = 0;

    this.gameObjects = new Array();

    this.needReorder = false;

    this.cameraEnable = function (_cameraMovement)
    {
    	this.cameraMovement = _cameraMovement;
    }
    

   // this.state.create = this.create;
    this.destroy = function ()
    {
        for (var k = 0; k < this.stateItems.length; k++) {
            this.stateItems[k].destroy();
        }
        for (var k = 0; k < this.gameObjects.length; k++) {
            this.gameObjects[k].destroy();
        }
        this.stateItems.length = 0;
        this.gameObjects.length = 0;
        this.commonItems.length = 0;
        if (this.stateTimer)
        {
            this.stateTimer.destroy();
            this.stateTime = 0; //время с начала состояния
            this.stateTimer = 0;
        }
    }
   

    this.create = function (_EnableTimer) {

        console.log("Game state " + this.stateNumber + " create. Timer state = " + _EnableTimer + ". Time : " + game.time.totalElapsedSeconds());

        var stateName = 'state' + this.stateNumber;
        var stateConfig = game.cache.getJSON(stateName);
        var stateActionsConfig = game.cache.getJSON(stateName + 'actions');

        

        for (var k = 0; k < stateConfig.Items.length; k++) {
            this.stateItems.push(new GameItem(stateConfig.Items[k],0));
            //отображаем объекты в состоянии по умолчанию
            this.stateItems[k].create(0,0);
        }

        for (var k = 0; k < this.gameObjects.length; k++) {
            this.gameObjects[k].create();
            //отображаем объекты в состоянии по умолчанию
            //this.stateItems[k].create();
        }

        console.log("Finish create items. Time : " + game.time.totalElapsedSeconds());

        //раскладываем по оси Z все элементы
        //orderByZ(this.stateItems);

        //for (var k = 0; k < this.gameObjects.length; k++) {
        //    orderByZ(this.gameObjects[k].objectItems);
        //}

        console.log("Finish orderByZ items. Time : " + game.time.totalElapsedSeconds());

        //загружаем игровые события
        //console.log("stateActionsConfig.ItemsCount " + stateActionsConfig.ItemsCount);
        //console.log(" _stateItems.length " + _stateItems.length);

        console.log("addActions : " + stateActionsConfig.ItemsCount);
        if (stateActionsConfig.ItemsCount > 0)
        {
            for (var k = 0; k < this.stateItems.length; k++) {
                //загружаем события
                this.stateItems[k].addActions(stateActionsConfig.Items);
            }

            console.log("Finish addActions items. Time : " + game.time.totalElapsedSeconds());
        }
        

        

       //this.state.render();

       if (_EnableTimer == true)
       {
           console.log("Create timer");
           this.stateTime = 0;
           this.stateTimer = game.time.create(false);
           this.stateTimer.loop(100, this.updateTimer, this);
           this.stateTimer.start();
       }

       for (var k = 0; k < this.stateItems.length; k++) {
           this.stateItems[k].startActions();
       }

       console.log("Finish startActions items. Time : " + game.time.totalElapsedSeconds());

       this.createCommonItems();

       this.reorder();

       console.log("Finish create state. Time : " + game.time.totalElapsedSeconds());

       
    }

    this.createCommonItems = function() {
        console.log("createCommonItems");
       

        var stateConfig = game.cache.getJSON("common");

        
        //functions['actionRightArrowOnClick'] = actionRightArrowOnClick;
        // functions['actionReplayOnClick'] = actionReplayOnClick;


        for (var k = 0; k < stateConfig.ItemsCount; k++) {
            this.commonItems.push(new GameItem(stateConfig.Items[k]));
            //отображаем объекты в состоянии по умолчанию
            this.commonItems[k].create(0, 0);
        }

        initMusicState();
    }

    this.addObject = function (_object)
    {
        console.log("addObject");
        this.gameObjects.push(_object);
    }


    this.addAction = function(_ActionConfig)
    {
        console.log("add one action");
        for (var k = 0; k < this.stateItems.length; k++) {
            //загружаем события
            this.stateItems[k].addActions(_ActionConfig.Items);
        }
    }

    this.reorder = function()
    {
        //раскладываем по оси Z все элементы
        //обновляем порядок изображений
        var testItems = new Array();
        for (var k = 0; k < this.stateItems.length; k++) {
            testItems.push(this.stateItems[k])
        }
        for (var k = 0; k < this.gameObjects.length; k++) {
            testItems.push(this.gameObjects[k])
        }
        orderByZ(testItems);
        orderByZ(this.commonItems);
        //reorderCommon();
    }

    this.getItemByName = function(_name)
    {
        var res = 0;

        for (var k = 0; k < this.stateItems.length; k++)
        {
            
            if (this.stateItems[k].name == _name)
            {
                return this.stateItems[k];
            }
        }

        for (var k = 0; k < this.stateItems.length; k++) {
            res = this.stateItems[k].getItemByName(_name);
            if (res != 0) {
                return res;
            }
        }
        return 0;
    }

    this.getCommonByName = function (_name) {
        var res = 0;

        for (var k = 0; k < this.commonItems.length; k++) {

            if (this.commonItems[k].name == _name) {
                return this.commonItems[k];
            }
        }
        return 0;
    }
    
 

    this.updateTimer = function()
    {
       // console.log("Update timer");
        this.stateTime += 100;
        this.executeActions();
    }

    this.executeActions = function()
    {
        for (var k = 0; k < this.stateItems.length; k++) {
            this.stateItems[k].executeActions(this.stateTime);
        }
    }
    
    this.processOnUp = function()
    {
    	this.tap = false;
    }
    
    this.processMovement = function()
    {
    //	return;
    	if (this.cameraMovement==true && this.tap==true && g_leftButtonTap==false && g_rightButtonTap==false)
    	{
    		var deltaX;
    		var cameraX;
    		deltaX = game.input.x - this.lastX;
    		cameraX = game.camera.x;
    		game.camera.x -= deltaX;
    		this.lastX = game.input.x;
    		
    		//console.log("move common " + (game.camera.x-cameraX));
    		for (var k = 0; k < this.commonItems.length; k++) {
    	           this.commonItems[k].remove(game.camera.x,0);
  	        }
    		for (var k=0;k<this.gameObjects.length;k++)
    		{
    			if (this.gameObjects[k].visible == true)
    			{
    				this.gameObjects[k].remove(game.camera.x+this.gameObjects[k].cameraX,this.gameObjects[k].y);
    			}
    		}
    		this.getItemByName("3_left").remove(game.camera.x,0);
    		this.getItemByName("3_right").remove(game.camera.x,0);
    		//g_Girl.remove(game.camera.x+250,gGirlY);
    	}
    }
    
    this.moveCamera = function(deltaX)
    {
    		var cameraX = game.camera.x;
    		game.camera.x -= deltaX;
    		
    		//console.log("move common " + (game.camera.x-cameraX));
    		for (var k = 0; k < this.commonItems.length; k++) {
    	           this.commonItems[k].remove(game.camera.x,0);
  	        }
    		for (var k=0;k<this.gameObjects.length;k++)
    		{
    			if (this.gameObjects[k].visible == true)
    			{
    				this.gameObjects[k].remove(game.camera.x+this.gameObjects[k].cameraX,this.gameObjects[k].y);
    			}
    		}
    		this.getItemByName("3_left").remove(game.camera.x,0);
    		this.getItemByName("3_right").remove(game.camera.x,0);
    }

    this.processOnDown = function()
    {
    	this.tap = true;
    	this.lastX = game.input.x;
    	
        var x;
        var y;
        
        if (game.input.x>10 &&  game.input.x<110 && game.input.y>558 &&  game.input.y<642) 
        {
        	return;
        }
        
        if (game.input.x>851 &&  game.input.x<951 && game.input.y>558 &&  game.input.y<642) 
        {
        	return;
        }

        var testItem = "";
        var clickedItem = "";
       
        x = game.input.x+game.camera.x;
        y = game.input.y+game.camera.y;
        
        

        console.log("X :" + x + ", Y : " + y);
      
        for (var k = 0; k < this.stateItems.length; k++) {
            testItem = this.stateItems[k].checkClick(x, y);
            if (testItem != "") {
                if (clickedItem == "") {
                    clickedItem = testItem
                }
                else if (clickedItem.z > testItem.z) {
                       
                        clickedItem = testItem;
                    }
                
            }
        }
        if (clickedItem != "")
        {
            console.log("clickedItem :" + clickedItem.name);
            for (var k=0;k<this.gameObjects.length;k++)
            {
                if (this.gameObjects[k].visible == true)
                {
                    this.gameObjects[k].SelectItem(clickedItem);
                    this.gameObjects[k].redraw();
                }
            }
            MainOnClick(clickedItem);
        }
        
    }
}


